/**
 * $Id: tunnel-server.cpp,v 1.24 2008/06/06 11:38:37 pensil Exp $
 * Copyright (c) 2008 Pensil - www.pensil.jp
 * 
 * MHPp glT[o[\tg
 */
#define DLLAPI extern "C" __declspec(dllexport)

#include "tunnel-server.h"
#include "tunnel-common.h"

extern bool LocalConnect(SOCKET_EX *);

#include <iostream>

//#include <tlhelp32.h>
#include <conio.h>

using namespace std;


const int kBufferSize = 32767;

//TCHAR szServer[256];
//TCHAR szPort[10];

const int maxOfSessions = 100;
const int maxOfUsers = 100;
int limitOfSessions = maxOfSessions;

SOCKET_EX sessions[maxOfSessions];

void AcceptConnections(SOCKET ListeningSocket);
bool EchoIncomingPackets(SOCKET_EX* sdex);
int GetIdolSession(void);
void LogSessionsStatus(void);

//char sb[4096]; //XbhԂœgpȂ悤Ƀ[Jϐ
#define SB_SIZE 256
char macchar[64];
bool useSSID = true;

void DefaultServerLogHandler(const char *)
{
}

server_log_handler slog2 = DefaultServerLogHandler;

void slog(const char *logText)
{
	ServerLogOut(logText);
	slog2(logText);
}

DLLAPI void _stdcall SetServerLogHandler(server_log_handler handler)
{
	slog2 = handler;
}

void PrintMac(MAC_ADDRESS* mac)
{
	snprintf(macchar, sizeof(macchar), "%02X:%02X:%02X:%02X:%02X:%02X", mac->addr[0], mac->addr[1], mac->addr[2], mac->addr[3], mac->addr[4], mac->addr[5]);
}

/**
 * 󂫃ZbV擾
 */
int GetIdolSession(void) {

	int count = 0;
	for (int i = 0; i < maxOfSessions; i++) {
		if (sessions[i].state != STATE_IDOL) {
			count++;
		}
	}
	if (count >= limitOfSessions) {
		return -1;
	}
	for (int i = 0; i < maxOfSessions; i++) {
		if (sessions[i].state == STATE_IDOL) {
			return i;
		}
	}
	return -1;
}

void LogSessionsStatus(void)
{
	char sb[SB_SIZE];
	int idle = 0, mallocked = 0, wait = 0, connected  = 0, closed = 0, error = 0;
	for (int i = 0; i < maxOfSessions; i++) {
		switch (sessions[i].state) {
			case STATE_IDOL: idle++; break;
			case STATE_MALLOCKED: mallocked++; break;
			case STATE_WAITTOCONNECT: wait++; break;
			case STATE_CONNECTED: connected++; break;
			case STATE_CLOSED: closed++; break;
			default: error++; 
		}
	}
	snprintf(sb, sizeof(sb), "ZbVFidl=%d,mal=%d,wai=%d,con=%d,clo=%d,err=%d", idle,mallocked,wait,connected,closed,error);
	slog(sb);
}

/**
 * ZbV̗LeXg
 */
int isValidSession(SOCKET_EX * sdex)
{
	return(sdex->state == STATE_CONNECTED // ڑĂ
		&& sdex->info.ping >= 0 //  LpingԂĂ
	);
}

/**
 * MR}hɑ΂鏈
 */
void doServerCommand(SOCKET_EX * sdex, const DATA_HEADER * _dh, const char * _data)
{
	DATA_HEADER rdh;
	DATA_HEADER * dh = &rdh;
	memcpy(dh, _dh, sizeof(DATA_HEADER));
	char data[4096];
	memcpy(data, _data, (int)dh->dsize);
	static const u_char bc[6] = {0xff,0xff,0xff,0xff,0xff,0xff};
	char sb[SB_SIZE];

	int findMac;

	//printf("%d  '%c'R}h (%d oCg) MB\n", sdex->number, dh->dtype, (int)dh->dsize);
    if (dh->dtype == 'C') {
		// R}h C:`bg T:glpPbg
		// MpPbĝ܂܃_CNg
		dh->doption = (char)sdex->number;
		dh->dtype = 'c';
    
    	// LȃZbVSΏۂɂ
    	for (int i = 0; i < maxOfSessions; i++) {

			// ̑MWbN̓XbhׂƎvEEE
			// Ă݂
			if (sessions[i].state == STATE_CONNECTED) {

				// R}hM
                //if (SendCommandByThread(sessions[i].sd, &dh, acReadBuffer)) {
	            //int nTemp = SendCommand(sessions[i].sd, &dh, data);
	            if (SendCommand(&sessions[i], dh, data)) {
					//printf("%d  %d ɓ] (%doCg)\n", sdex->number, i, (int)dh->dsize);
					//sessions[i].sendSize += nReadBytes;
                } else {
					snprintf(sb, sizeof(sb), "%d  %d ɓ]sBؒfꂽB (%doCg)", sdex->number, i, (int)dh->dsize);
					slog(sb);
					//sessions[i].type = 0;
                    //return false;
                }
	        }
        }

		data[(int)dh->dsize] = 0;
		snprintf(sb, sizeof(sb), "%d: %s (S%d->R%d) (Last: S%d R%d)", (int)dh->doption , data, sdex->sendCount, dh->recvCount, SendPacketSize(sdex), RecvPacketSize(sdex));
		slog(sb);

    } else if (dh->dtype == 'D') {
		// R}h D:tell ɑR}h
		// w肵ɂ̂ݒʒm
		
		char commandType[30];
		char tellTo[30];
		char text[4096];
		char buffer[4096];
		data[(int)dh->dsize] = 0;
		sscanf(data, "/%s %s %4096s", commandType, tellTo, text);
		
		dh->doption = (char)sdex->number;
		dh->dtype = 'c';
    
    	// LȃZbVSΏۂɂ
    	for (int i = 0; i < maxOfSessions; i++) {

			// ̑MWbN̓XbhׂƎvEEE
			// Ă݂
			if (sessions[i].state == STATE_CONNECTED) {

				if (strcmp(sessions[i].info.szNickName, tellTo) == 0) {

					snprintf(buffer, sizeof(buffer), "%s << %s", tellTo, text);
					dh->dsize = strlen(buffer);
			        SendCommand(sdex, dh, buffer);

					snprintf(buffer, sizeof(buffer), "%s >> %s", sdex->info.szNickName, text);
					dh->dsize = strlen(buffer);
		            SendCommand(&sessions[i], dh, buffer);
					snprintf(sb, sizeof(sb), "%s >> %s", sdex->info.szNickName, text);
					slog(sb);
				}
	        }
        }

    } else if (dh->dtype == 'Y') {
		// R}h Y:party ɑR}h
		// w肵ɂ̂ݒʒm
		
		char commandType[30];
		//char tellTo[30];
		char text[4096];
		data[(int)dh->dsize] = 0;
		sscanf(data, "/%s %4096s", commandType, text);
		
		dh->doption = (char)sdex->number;
		dh->dtype = 'c';
    
    	// LȃZbVSΏۂɂ
    	for (int i = 0; i < maxOfSessions; i++) {

			// ̑MWbN̓XbhׂƎvEEE
			// Ă݂
			if (sessions[i].state == STATE_CONNECTED) {

				if (strcmp(sessions[i].info.szSSID, sdex->info.szSSID) == 0) {

					char buffer[4096];
					snprintf(buffer, sizeof(buffer), "(%s) %s", sdex->info.szNickName, text);
					dh->dsize = strlen(buffer);
		            SendCommand(&sessions[i], dh, buffer);
					snprintf(sb, sizeof(sb), "(%s) %s", sdex->info.szNickName, text);
					slog(sb);
				}
	        }
        }

    } else if (dh->dtype == 'T') {
		// R}h T:glpPbg
		// MpPbĝ܂܃_CNg
		dh->doption = (char)sdex->number;
		dh->dtype = 't';
    
		// MMACAhXXgɒǉ
		findMac = -1;
		for (int i = 0; i < maxMacAddr; i++) {
			if (sdex->mac[i].active) {
				if (memcmp((char *)&sdex->mac[i], &data[6], 6) == 0) {
					findMac = i;
					sdex->mac[i].last_clock = clock();
					break;
				}
			}
		}
		if (findMac == -1) {
			for (int i = 0; i < maxMacAddr; i++) {
				if (!sdex->mac[i].active) {
					memcpy((char *)&sdex->mac[i], &data[6], 6);
					sdex->mac[i].active = true;
					PrintMac(&sdex->mac[i]);
					snprintf(sb, sizeof(sb), "PSPF(%d %d): MACAhX = %s", sdex->number, i, macchar);
					slog(sb);
					sdex->info.pspCount++;
					sdex->mac[i].last_clock = clock();
					break;
				}
			}
		}

    	// LȃZbVSΏۂɂ
    	for (int i = 0; i < maxOfSessions; i++) {

			// ̑MWbN̓XbhׂƎvEEE
			// Ă݂
			if (sessions[i].state == STATE_CONNECTED && sessions[i].number != sdex->number) {

				bool yesSend = false;

				// SSIDmɃpPbggl
				if (!useSSID || strcmp(sdex->info.szSSID, sessions[i].info.szSSID) == 0) {
					// ܂Au[hLXgM_CNg
					if (memcmp(&bc, data, 6) == 0) {
						yesSend = true;
					} else {
						
						// MMACAhXXgɑ݂邩mF
						for (int m = 0; m < maxMacAddr; m++) {
							if (sessions[i].mac[m].active) {
								if (memcmp((char *)&sessions[i].mac[m], data, 6) == 0) {
									yesSend = true;
									break;
								}
							}
						}
					}
				}
				
				// R}hM
                //if (SendCommandByThread(sessions[i].sd, &dh, acReadBuffer)) {
	            //int nTemp = SendCommand(sessions[i].sd, &dh, data);
	            if (yesSend) {
		            if (SendCommand(&sessions[i], dh, data)) {
//						printf("%d  %d ɓ] (%doCg)\n", sdex->number, i, (int)dh->dsize);
						//sessions[i].sendSize += nReadBytes;
	                } else {
						snprintf(sb, sizeof(sb), "%d  %d ɓ]sBؒfꂽB (%doCg)", sdex->number, i, (int)dh->dsize);
						slog(sb);
						//sessions[i].type = 0;
	                    //return false;
	                }
	            }
	        }
        }

    } else if (dh->dtype == 'A') {

		// R}h A:V[U[ꗗmFR}h
		dh->dtype = 'a';		
		int count = 0;    
    	// LȃZbVSΏۂɂ
    	for (int i = 0; i < maxOfSessions; i++) {
			if (sessions[i].state == STATE_CONNECTED) {
				count++;
	        }
        }        
        dh->doption = (char)count;
        dh->dsize = sizeof(USER_INFO) * count;
        USER_INFO * ui;
        ui = (USER_INFO *)malloc(sizeof(USER_INFO)*count);    
    	count = 0;
    	// LȃZbVSΏۂɂ
    	for (int i = 0; i < maxOfSessions; i++) {
			if (sessions[i].state == STATE_CONNECTED) {				
				memcpy(&ui[count], &sessions[i].info, sizeof(USER_INFO));
				count++;
	        }
        }        
        SendCommand(sdex, dh, (char *)ui);
        free(ui);
 
    } else if (dh->dtype == 'U') {

		// R}h U:[U[ꗗmFR}h
		// MpPbĝ܂܃_CNg
		dh->doption = (char)sdex->number;
		dh->dtype = 'u';
    
    	// LȃZbVSΏۂɂ
    	for (int i = 0; i < maxOfSessions; i++) {

			// ̑MWbN̓XbhׂƎvEEE
			// Ă݂
			if (sessions[i].state == STATE_CONNECTED) {

	            SendCommand(&sessions[i], dh, data);
	        }
        }

    } else if (dh->dtype == 'S' || dh->dtype == 'I') {
    	
    	int ping = sdex->info.ping;
		if (ping < 0) ping = 0; //pingvł̌isValidSection()ʂ悤
		int pspCount = sdex->info.pspCount;
		memcpy(&sdex->info, data, sizeof(USER_INFO));
    	sdex->info.ping = ping;
    	sdex->info.pspCount = pspCount;
		if (sdex->info.majorVersion != MAJOR_VERSION || sdex->info.minorVersion != MINOR_VERSION) {
			DATA_HEADER dht;
	    	dht.dtype = 'c';
	    	char serverComment[512];
	    	snprintf(serverComment, sizeof(serverComment), "o[Wv܂: T[o[Ver%d.%d NCAgVer%d.%d", MAJOR_VERSION, MINOR_VERSION, sdex->info.majorVersion, sdex->info.minorVersion);
	    	dht.dsize = strlen(serverComment);
	        SendCommand(sdex, &dht, serverComment);
		}

		if (dh->dtype == 'I') {	
			// R}h U:[U[ꗗmFR}h
			// MpPbĝ܂܃_CNg
			int i = (int)dh->doption;
			dh->dtype = 'i';
			dh->doption = (char)sdex->number;
			
			if ( i >= 0 && i < maxOfSessions && sessions[i].state == STATE_CONNECTED) {
				SendCommand(&sessions[i], dh, data);
	        }
		} else {
	    	// LȃZbVSΏۂɂ
//			snprintf(sb, sizeof(sb), "%d: %s SSID ->%s USERID ->%s", sdex->number, sdex->info.szNickName, sdex->info.szSSID, sdex->info.szUID);
//			slog(sb);

			// R}h A:V[U[ꗗmFR}h
			dh->dtype = 'a';		
			int count = 0;    
	    	// LȃZbVSΏۂɂ
	    	for (int i = 0; i < maxOfSessions; i++) {
				if (isValidSession(&sessions[i]) ) {//sessions[i].state == STATE_CONNECTED) {
					count++;
		        }
	        }        
	        USER_INFO * ui;
	        ui = (USER_INFO *)malloc(sizeof(USER_INFO)*count);    
	        dh->doption = (char)count;
	        dh->dsize = sizeof(USER_INFO) * count;
	    	count = 0;
	    	// LȃZbVSΏۂɂ
	    	for (int i = 0; i < maxOfSessions; i++) {
				if (isValidSession(&sessions[i]) ) {//sessions[i].state == STATE_CONNECTED) {
					memcpy(&ui[count], &sessions[i].info, sizeof(USER_INFO));
					count++;
		        }
	        }

	    	// LȃZbVSΏۂɂ
	    	for (int i = 0; i < maxOfSessions; i++) {
	
				if (isValidSession(&sessions[i]) ) {//sessions[i].state == STATE_CONNECTED) {
	
			        SendCommand(&sessions[i], dh, (char *)ui);
		        }
	        }

	        free(ui);
		}

    } else if (dh->dtype == 'P') {
    	dh->dtype = 'p';
        if (SendCommand(sdex, dh, data)) {
//			printf("ping(%d/%d)\n", sdex->sendCount, sdex->recvCount);
        } else {
//			printf("pings\n");
        }
	} else if (dh->dtype == 'p') {
//		if ((int)dh->dsize == sizeof(clock_t)) {
		clock_t pingClock;
		memcpy((char *)&pingClock, data, sizeof(int));
		sdex->info.ping = clock() - pingClock;
//		snprintf(sb, sizeof(sb), "now:%d ping:%d result:%d sdex->info.ping:%d", clock(), pingClock, (clock() - pingClock), sdex->info.ping);
//		slog(sb);
//		}

		// SZbVMACAhX
		// (ĎXbhԂɂłɒuĂ)
		time_t expireMacClock = clock() - 10000; //
		for (int i = 0; i < maxOfSessions; i++) {
			if (sessions[i].state != STATE_CONNECTED)
				continue;
			for (int m = 0; m < maxMacAddr; m++) {
				if (sessions[i].mac[m].active && sessions[i].mac[m].last_clock < expireMacClock) {
					sessions[i].mac[m].active = false;
					PrintMac(&sessions[i].mac[m]);
					snprintf(sb, sizeof(sb), "PSPF(%d %d): MACAhX = %s", i, m, macchar);
					slog(sb);
					sessions[i].info.pspCount--;
					continue;
				}
			}
		}

		// R}h A:V[U[ꗗmFR}h
		dh->dtype = 'a';		
		int count = 0;    
    	// LȃZbVSΏۂɂ
    	for (int i = 0; i < maxOfSessions; i++) {
			if (isValidSession(&sessions[i]) ) {//sessions[i].state == STATE_CONNECTED) {
				count++;
	        }
        }        
        dh->doption = (char)count;
        dh->dsize = sizeof(USER_INFO) * count;
        USER_INFO * ui;
        ui = (USER_INFO *)malloc(sizeof(USER_INFO)*count);    
    	count = 0;
    	// LȃZbVSΏۂɂ
    	for (int i = 0; i < maxOfSessions; i++) {
			if (isValidSession(&sessions[i]) ) {//sessions[i].state == STATE_CONNECTED) {
				memcpy(&ui[count], &sessions[i].info, sizeof(USER_INFO));
				count++;
	        }
        }        
        SendCommand(sdex, dh, (char *)ui);
        free(ui);

//		printf("%d : ping(S%d->R%d S%d->R%d)\n", sdex->number , sdex->sendCount, dh->recvCount, dh->sendCount ,sdex->recvCount);
    } else {
		snprintf(sb, sizeof(sb), "  T|[gÕR}h [%c]", dh->dtype);
		slog(sb);
        //return false;
    }
}

void doServerConnect(SOCKET_EX *sdex)
{
	sdex->info.pspCount = 0;

	DATA_HEADER dh;
	char data[256];
	
	// EFJbZ[W̑t
	snprintf(data, sizeof(data), "!!! Welcome to MHP Tunnel Server Ver%d.%d patched !!!",MAJOR_VERSION, MINOR_VERSION);
	dh.dtype = 'c';
	dh.dsize = (short)strlen(data);
	SendCommand(sdex,&dh,data);
}

void doServerClose(SOCKET_EX * sdex)
{
	DATA_HEADER dh;
	char data[256];
	char sb[SB_SIZE];
	
	snprintf(data, sizeof(data), "%d ؒf܂", sdex->number);
/*
	if (sdex->state == STATE_ERROR) {
		slog(WSAGetLastErrorMessage("WSA Last Error"));
	}
*/
	if (sdex->state == STATE_ERROR) {
		int err = WSAGetLastError();
		if (sdex->recvState == -1) {
			snprintf(sb, sizeof(sb), "%d ؒf(%d):MG[(%d)", sdex->number, sdex->state, err);
		} else if (sdex->sendState == -1) {
			snprintf(sb, sizeof(sb), "%d ؒf(%d):MG[(%d)", sdex->number, sdex->state, err);
		} else if (sdex->sendCountBefore == 0) {
			snprintf(sb, sizeof(sb), "%d ؒf(%d):pPbgXG[(%d)", sdex->number, sdex->state, err);
		} else {
			snprintf(sb, sizeof(sb), "%d ؒf(%d):G[(%d)", sdex->number, sdex->state, err);
		}
	} else if (sdex->state == STATE_CLOSED) { 
		snprintf(sb, sizeof(sb), "%d ؒf܂", sdex->number);
	} else {
		snprintf(sb, sizeof(sb), "%d ؒf(%d)", sdex->number, sdex->state);
	}
	slog(sb);

	LogSessionsStatus();
	dh.dtype = 'z';
	dh.dsize = (short)strlen(data);

	// LȃZbVSΏۂɂ
	for (int i = 0; i < maxOfSessions; i++) {

		if (sessions[i].state == STATE_CONNECTED) {

			// R}hM
            //if (SendCommand(&sessions[i], &dh, data)) {
            //}
        }
	}
}

DWORD WINAPI DoListening(void * _Socket)  
{
	char sb[SB_SIZE];
	SOCKET ListeningSocket = * ((SOCKET *)_Socket);
    if (ListeningSocket == INVALID_SOCKET) {
        //printf("\n%s\n", WSAGetLastErrorMessage("Xi[G["));
        return 3;
    }

	// Ђڑ҂
    while (1) {
	    slog("ڑ҂Ă܂...");
		int i = GetIdolSession();
		while(i == -1) {
			// AChZbVȂ̂ő҂Ă݂
			Sleep(100);
			i = GetIdolSession();
		};
		if (AcceptConnection(&sessions[i], ListeningSocket)) {
			snprintf(sb, sizeof(sb), "ڑZbVԍ : %d", i);
			slog(sb);
//            cout << "NCAg " <<
//                    inet_ntoa(sessions[i].sinRemote.sin_addr) << ":" <<
//                    ntohs(sessions[i].sinRemote.sin_port) << "." <<
//                    endl;
        }
        else {
        	snprintf(sb, sizeof(sb), "%s", WSAGetLastErrorMessage("accept() failed"));
        	slog(sb);
        }
    }
}

HANDLE hThreads[20];
SOCKET listenSocket[20];
int numOfThread;
ARENA * _arena;

DLLAPI bool _stdcall OpenServer(struct ARENA * arena)
{
	_arena = arena;
	char sb[SB_SIZE];

	int nPort = arena->port;
	if (!InitTunnel()) {
		return false;
	}

	int port = htons(nPort);
//	slog("471:OpenServer");

    // ZbVXg̏
	for (int i = 0; i < maxOfSessions; i++) {
		sessions[i].sd = INVALID_SOCKET;
		sessions[i].state = STATE_IDOL;
		sessions[i].number = i;
		sessions[i].doClose = doServerClose;
		sessions[i].doCommand = doServerCommand;
		sessions[i].doConnect = doServerConnect;
	}

	// ̃zXg𓾂
//	slog("484:OpenServer");
	char ac[80];
    if (gethostname(ac, sizeof(ac)) == SOCKET_ERROR) {

    	// ̃zXg擾ł܂ł
    	snprintf(sb, sizeof(sb), "[JzXg %s łB", ac);
    	slog(sb);
        return 1;
    }

    // ̃zXgAIPAhX𓾂
//	slog("495:OpenServer");
    struct hostent *phe = gethostbyname(ac);
    if (phe == 0) {

    	// IPAhX擾ł܂ł
        return 2;
    }

    // SĂIPAhXő҂󂯂
//	slog("504:OpenServer");
    numOfThread = 0;
    for (int i = 0; phe->h_addr_list[i] != 0; ++i) {
        listenSocket[numOfThread] = socket(AF_INET, SOCK_STREAM, 0);
        if (listenSocket[numOfThread] != INVALID_SOCKET) {
            sockaddr_in sinInterface;
            sinInterface.sin_family = AF_INET;
		    struct in_addr addr;
		    memcpy(&addr, phe->h_addr_list[i], sizeof(struct in_addr));
	    	memcpy(&sinInterface.sin_addr.s_addr, phe->h_addr_list[i], sizeof(struct in_addr));
            sinInterface.sin_port = port;
	    	snprintf(sb, sizeof(sb), "AhX %s:%d łB", inet_ntoa(addr), nPort);
	    	slog(sb);
            if (bind(listenSocket[numOfThread], (sockaddr*)&sinInterface, 
                    sizeof(sockaddr_in)) != SOCKET_ERROR) {
                listen(listenSocket[numOfThread], SOMAXCONN);
                hThreads[numOfThread] = CreateThread(0, 0, DoListening, (void*)&listenSocket[numOfThread], 0, NULL);
                numOfThread++;
            } else {
            	// binds
            }
        }
        Sleep(100);
    }

//	slog("528:OpenServer");
	return 0;
}

DLLAPI void _stdcall WaitServer()
{
    // http://msdn.microsoft.com/ja-jp/library/cc429423.aspx
	WaitForMultipleObjects(numOfThread, hThreads, true, INFINITE);
}

DLLAPI bool _stdcall CloseServer()
{
	for (int i = 0; i < numOfThread; i++) {
		TerminateThread(hThreads[numOfThread], 3);
	}
	return true;
}

bool LocalConnect(SOCKET_EX * sdex)
{
	int i = GetIdolSession();
	if(i == -1) {
		return false;
	};
	InitConnection(&sessions[i], 256);
	sessions[i].doClose = doServerClose;
	sessions[i].doCommand = doServerCommand;
	sessions[i].doConnect = doServerConnect;
	
	sessions[i].localConnect = sdex;
	sdex->localConnect = &sessions[i];
    StartConnection(&sessions[i]);
    StartConnection(sdex);
	return true;
}

void UseSSIDFilter(bool value)
{
	useSSID = value;
}

DLLAPI void _stdcall GetServerSetting(struct ARENA * arena)
{
	char szPort[10];
	GetSetting("Port" , "443", szPort , 10);

	// |[gԍ
    arena->port = atoi(szPort);
    arena->majorVersion = MAJOR_VERSION;
    arena->minorVersion = MINOR_VERSION;
    
	// őڑ
	GetSetting("MaxSessions" , "100", szPort , 10);
	int x = atoi(szPort);
	if (x > maxOfSessions || x <= 0) {
		x = maxOfSessions;
	}
	limitOfSessions = x;
}

